﻿package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/dao"
	"code.fnuoos.com/zhimeng/model.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/zhimeng/model.git/utils/logx"
	"xorm.io/xorm"
)

func NewMediumDomainDb(engine *xorm.Engine) dao.MediumDomainDao {
	return &MediumDomainDb{Db: engine}
}

type MediumDomainDb struct {
	Db *xorm.Engine
}

func (m MediumDomainDb) GetMediumDomain(mediumId int) (medium *model.MediumDomain, err error) {
	medium = new(model.MediumDomain)
	has, err := m.Db.Where("medium_id =?", mediumId).Get(medium)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return medium, nil
}

func (m MediumDomainDb) MediumDomainInsert(medium *model.MediumDomain) (int64, error) {
	insertAffected, err := m.Db.InsertOne(medium)
	if err != nil {
		return 0, err
	}
	return insertAffected, nil
}
